/**
*
* CSS settings for generic framework components.
*
*/

html,
body {
  width: 100%;
  height: 100%;
  margin: 0px;
  padding: 0px;
  overflow: hidden;
  font-family: "Inter", sans-serif !important;
  font-size: 12pt;
}

h1,
h2,
h3,
h4,
h5,
h6 {
  font-weight: 700;
}

/* MapBox Elements */
#map {
  width: calc(100% - 500px);
  height: 100%;
  float: left;
  z-index: 0;
}

.mapboxgl-popup-content {
  text-align: left;
  font-size: 8pt;
  width: auto;
  max-width: 400px;
  pointer-events: none;
  background: linear-gradient(
    180deg,
    rgba(245, 245, 255, 1) 80%,
    rgba(230, 230, 240, 1) 100%
  );
}
.mapboxgl-popup-content p {
  font-style: italic;
  color: grey;
}

/* Digital Twin Controls */
#controlContainer {
  width: 250px;
  height: auto;
  position: fixed;
  top: 0;
  left: 0;
  margin: 20px;
  z-index: 1;

  color: white;
  font-family: "Inter", sans-serif !important;
  font-size: 10pt;
}
#controlContainer p {
  margin: 0 0 5px 0;
  font-weight: bold;
  font-size: 12pt;
}
#controlContainer a {
  color: white;
  text-decoration: none;
  padding-left: 10px;
}
#controlContainer a:hover {
  color: lightskyblue;
  text-decoration: underline;
}
#controlContainer label:hover {
  color: lightskyblue;
  text-decoration: underline;
}

/* Camera Controls */
#cameraContainer {
  background-color: rgba(0, 0, 0, 0.4);
  border-radius: 8px;
  margin-bottom: 10px;
  padding: 10px;
  line-height: 14pt;
}
#cameraContainer:hover {
  background-color: rgba(0, 0, 0, 0.6);
}

/* Terrain Controls */
#terrainContainer {
  background-color: rgba(0, 0, 0, 0.4);
  border-radius: 8px;
  padding: 10px;
  margin-bottom: 10px;
}
#terrainContainer:hover {
  background-color: rgba(0, 0, 0, 0.6);
}

/* Layer Tree Controls */
#layerContainer {
  background-color: rgba(0, 0, 0, 0.4);
  border-radius: 8px;
  padding: 10px;
  max-height: 550px;
}
#layerContainer:hover {
  background-color: rgba(0, 0, 0, 0.6);
}
#layerTree {
  padding-left: 0px;
}
#layerTree ul {
  padding-left: 15px;
}
#layerTree ul, li {
  list-style-type: none;
}
#layerTreeContainer {
  min-height: 30vh; 
  max-height: 50vh; 
  overflow-y: auto;
}
@media only screen and (max-height: 900px) {
  #layerTreeContainer {
    max-height: 25vh; 
    overflow-y: auto;
  }
}

/* Side Panel */
#sidePanel {
  z-index: 1;
  background-color: white;
  box-sizing: border-box;
  border: 1px solid grey;
  font-size: 11pt;
}
#slideButtonContainer img {
  margin: 6px;
  -webkit-transform: rotate(-90deg);
  -moz-transform: rotate(-90deg);
  -o-transform: rotate(-90deg);
  -ms-transform: rotate(-90deg);
  transform: rotate(-90deg);
}
#expandButtonContainer img {
  margin: 6px;
}
#slideButtonContainer img:hover {
  opacity: 50%;
  cursor: pointer;
}
#expandButtonContainer img:hover {
  opacity: 50%;
  cursor: pointer;
}
#sidePanel.small {
  position: relative;
  width: 500px;
  height: 100%;
  float: right;
  border-width: 0px 0px 0px 1px;
}
#sidePanel.large {
  position: absolute;
  top: 50px;
  left: 50px;
  width: calc(100% - 100px);
  height: calc(100% - 100px);
  border-width: 1px;
  border-radius: 8px;
}
#expandButtonContainer {
  float: right;
}
#sidePanel.large #expandButtonContainer {
  margin-top: -8px;
  margin-right: 20px;
  margin-left: calc(100% - 32px);
  width: 24px;
  height: 24px;
}
#sidePanel.collapsed {
  width: 28px;
}
#sidePanel.collapsed img.leftButton {
  margin: 6px;
  -webkit-transform: rotate(90deg);
  -moz-transform: rotate(90deg);
  -o-transform: rotate(90deg);
  -ms-transform: rotate(90deg);
  transform: rotate(90deg);
}

/* Side Panel Components */
#content-before {
  border-top: 1px solid lightgray;
  border-bottom: 1px solid lightgray;
  padding-top: 10px;
  padding-bottom: 10px;
  margin-bottom: 20px;
}
#sidePanelInner {
  width: calc(100% - 56px);
  margin-left: 28px;
  margin-right: 28px;
  display: flex;
  flex-direction: column;
  height: calc(100% - 20px);
}
#titleContainer {
  width: 100%;
  min-height: 40px;
  max-height: 80px;
  text-align: center;
  margin-bottom: 20px;
}
#titleContainer img:hover {
  opacity: 50%;
  cursor: pointer;
}
#propsContainer {
  margin-top: 10px;
  width: 100%;
  height: auto;
  font-size: 10pt;
}
#propsContainer td {
  min-height: 25px;
}
#propsContainer table {
  border-bottom: 1px solid lightgrey;
}
#contentContainer {
  margin-top: 10px;
  width: 100%;
  margin-bottom: 20px;
  overflow-y: hidden;
  display: flex;
  flex-direction: column;
  /* flex-grow: 1; */
  /* justify-content: space-between; */
}

#meta-tree {
  flex: 1;
  overflow-y: scroll;
}
#legendContainer {
  width: 100%;
  height: 300px;
  min-height: 300px;
  margin-bottom: 10px;
  border: 1px solid grey;
}
#footerContainer {
  text-align: center;
  width: 100%;
  height: 40px;
  position: absolute;
  bottom: 0;
}
#returnContainer {
  text-align: left;
  width: 100%;
  height: 100%;
  margin-bottom: 25px;
  display: none;
}
#footerContent {
  width: 100%;
  height: 100%;
}

/* W3 Legend component */
#legend {
  width: 150px !important;
  height: 298px !important;
  font-size: 10pt;

  -webkit-transform: rotate(0deg);
  -moz-transform: rotate(0deg);
  -o-transform: rotate(0deg);
  -ms-transform: rotate(0deg);
  transform: rotate(0deg);

  box-shadow: none;
}
.legend-right {
  height: 300px;
  width: calc(100% - 150px);
  float: right;
  position: relative;
}
.legend-right img {
  width: auto;
  height: auto;
  max-height: 100%;
  max-width: 100%;
  position: absolute;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  margin: auto;
  -webkit-transform: rotate(0deg) !important;
  -moz-transform: rotate(0deg) !important;
  -o-transform: rotate(0deg) !important;
  -ms-transform: rotate(0deg) !important;
  transform: rotate(0deg) !important;
}

/* Tooltip handling */
.tooltip {
  position: relative;
  display: inline-block;
}
.tooltip .tooltiptext {
  visibility: hidden;
  width: 120px;
  background-color: #808080;
  color: #fff;
  text-align: center;
  padding: 5px 0;
  border-radius: 6px;
  font-size: 9pt;

  position: absolute;
  z-index: 1;
  top: 100%;
  right: 50%;
}
.tooltip:hover .tooltiptext {
  visibility: visible;
}

/* Time Series components */
#time-series-container {
  flex: 1;
  font-size: 10pt;
}
#time-series-table-container {
  margin-top: 10px;
  height: calc(100% - 40px - 350px);
  max-height: calc(100% - 40px - 350px);
  border: 1px solid grey;
  position: relative;
  overflow-y: scroll;
}

#time-series-chart-container {
  margin-top: 20px;
  margin-bottom: 20px;
  height: 300px;
}
#time-series-control {
  margin-top: 15px;
  width: 100%;
  height: 25px;
}

#time-series-title {
  width: 100%;
  height: 25px;
  margin-bottom: 10px;
  border-bottom: 1px solid lightgrey;
}
#time-series-container label {
  width: calc(35% - 10px);
  height: 25px !important;
  float: left;
  text-align: right;
}
#time-series-container select {
  width: 65%;
  height: 25px !important;
  float: right;
  font-size: 9pt;
  text-align: right;
}

.time-series-table {
  border-spacing: 0px;
  border-collapse: separate;
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
}

.time-series-table th {
  background-color: #e1e1e1;
  border-bottom: 1px solid grey;
  color: #333333;
  height: 35px;
}
.time-series-table td {
  text-align: center;
  padding: 0px;
  font-size: 9pt;
  height: 25px;
}
.time-series-table tr:hover {
  background-color: #f5f5ff !important;
}

.time-series-table tr:nth-child(even) {
  background-color: #fafafa;
}

/* Group controls */
#selectionsContainer {
  background-color: rgba(0, 0, 0, 0.4);
  border-radius: 8px;
  padding: 10px;
  margin-top: 10px;
  min-height: 100px;
}
#selectionsContainer p {
  margin-bottom: 10px;
}
#selectContainer {
  height: 25px;
  margin-top: 5px;
}
#selectContainer label {
  display: inline-block;
  width: 29%;
  height: 25px;
}
#selectContainer select {
  width: 69%;
  height: 25px;
  font-size: 9pt;
}

#rootSelectContainer {
  height: 25px;
  margin-top: 5px;
}
#rootSelectContainer label {
  display: inline-block;
  width: 29%;
  height: 25px;
}
#rootSelectContainer select {
  width: 69%;
  height: 25px;
  font-size: 9pt;
}

#time-series-chart-container {
  margin-top: 20px;
  margin-bottom: 20px;
  height: 300px;
}

#chart-canvas {
  height: 100% !important;
  width: 100% !important;
}

#jsonTree {
  border-bottom: 1px solid lightgrey;
  height: calc(100% - 40px);
}
.json-key {
  font-weight: bold;
  margin-right: 0px !important;
  font-size: 10pt !important;
  font-family: "Inter", sans-serif !important;
  color: black !important;
}
.json-value {
  color: navy !important;
  font-size: 10pt !important;
  font-family: "Inter", sans-serif !important;
}
.json-separator {
  line-height: 1.25;
}
.json-size {
  font-size: 10pt !important;
  font-family: "Inter", sans-serif !important;
  color: rgb(100, 100, 100) !important;
}
.empty-icon {
  width: 12px !important;
  min-width: 12px !important;
}
.fa-caret-right:before {
  content: "" !important;
}
.fa-caret-down:before {
  content: "" !important;
}

/* Style the tab */
.json-tree-tabs {
  overflow: hidden;
  border: 1px solid #ccc;
  background-color: #f1f1f1;
}

/* Style the buttons that are used to open the tab content */
.json-tree-tabs button {
  background-color: inherit;
  float: left;
  border: none;
  outline: none;
  cursor: pointer;
  padding: 14px 16px;
  transition: 0.3s;
  width: 50%;
}

/* Change background color of buttons on hover */
.json-tree-tabs button:hover {
  background-color: #ddd;
}

/* Create an active/current tablink class */
.json-tree-tabs button.active {
  background-color: #ccc;
}

/* Style the tab content */
.json-tree-tabscontent {
  display: none;
  padding: 6px 12px;
  border: 1px solid #ccc;
  border-top: none;
}

#no-meta-container {
  background-color: rgb(240, 240, 240);
  color: rgb(100, 100, 100);
  text-align: center;
  height: 100%;
  width: 100%;
  display: table;
}

#no-meta-container p {
  display: table-cell;
  vertical-align: middle;
}

#developerContainer {
  background-color: rgba(0, 0, 0, 0.4);
  border-radius: 8px;
  padding: 10px;
  margin-top: 10px;
}

#linkedFilesContainer {
  background-color: rgba(0, 0, 0, 0.05);
  border-radius: 8px;
  padding: 10px;
}

#controlTitle {
  width: 100%;
  height: 24px;
  margin-bottom: 5px;
}
#controlTitle p {
  width: 50%;
  float: left;
}
#controlTitle .tooltip {
  padding-right: 5px;
  float: right;
}
#controlTitle .tooltip p {
  text-align: left;
  width: 20px;
  height: 18px;
  line-height: 18px;
  padding-top: 0px;
}

.switch {
  position: relative;
  display: block;
  width: 30px;
  height: 16px;
  float: right;
  margin-top: 2px;
  margin-right: 16px;
}
.switch input {
  opacity: 0;
  width: 0;
  height: 0;
}
.slider {
  position: absolute;
  cursor: pointer;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background-color: #ccc;
  -webkit-transition: 0.4s;
  transition: 0.4s;
}
.slider:before {
  position: absolute;
  content: "";
  height: 12px;
  width: 12px;
  left: 2px;
  bottom: 2px;
  background-color: white;
  -webkit-transition: 0.4s;
  transition: 0.4s;
}
input:checked + .slider {
  background-color: #2196f3;
}
input:focus + .slider {
  box-shadow: 0 0 1px #2196f3;
}
input:checked + .slider:before {
  -webkit-transform: translateX(13px);
  -ms-transform: translateX(13px);
  transform: translateX(13px);
}
.slider.round {
  border-radius: 34px;
}
.slider.round p {
  float: right;
  padding-left: 34px;
  padding-top: 2px;
  font-size: 8pt !important;
}
.slider.round:before {
  border-radius: 50%;
}

#tiltShift {
  display: block;
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  z-index: 0;
  pointer-events: none;
}

#select-feature {
  height: 30px;
  width: calc(85% - 50px);
  float: right;
  margin-right: 25px;
}

label[for="select-feature"] {
  height: 30px;
  width: 15%;
  float: left;
  margin-left: 25px;
  line-height: 30px;
}

#animationIntro {
  width: calc(100% - 20px);
  height: 100px;
  margin: 10px;
  font-size: 10pt;
  border-bottom: 1px solid rgb(230, 230, 230);
}
#animationContainer {
  width: 100%;
  height: calc(100% - 160px);
  display: flex;
  overflow-y: auto;
}
#animationLeft {
  width: 30%;
  padding: 10px;
  margin: 10px 5px 10px 10px;
  flex: 0 1 auto;
  background-color: rgb(240, 240, 240);
  border-radius: 8px;
}
#animationRight {
  position: relative;
  width: 70%;
  margin: 10px 10px 10px 5px;
  padding: 10px;
  flex: 0 1 auto;
  background-color: rgb(240, 240, 240);
  border-radius: 12px;
}

#animationLeft table {
  margin: auto;
  border-collapse: separate;
  border-spacing: 5px;
  font-size: 11pt;
}
#animationLeft tr {
  height: 25px;
}
#animationLeft tr input {
  width: 100%;
  height: 25px;
}

#animationRow {
  height: 30px;
  margin-bottom: 6px;
}
#animationRow select {
  height: 30px;
  width: 10%;
  font-size: 9pt;
  float: left;
  margin-right: 3px;
}
#animationRow input {
  height: 25px;
  width: 7%;
  font-size: 9pt;
}
#animationRow input.long {
  width: 14%;
}
#deleteRow {
  width: 30px;
  height: 30px;
  float: right;
  cursor: pointer;
  display: flex;
  justify-content: center;
}
#deleteRow img {
  display: block;
  margin: auto;
}

#animationAddButton {
  height: 25px;
  width: calc(100% - 60px);
  border-radius: 6px;
  background-color: rgb(200, 200, 200);
  text-align: center;
  cursor: pointer;
  font-size: 16pt !important;
  position: absolute;
  bottom: 10px;
  left: 30px;
}

#animationBottom {
  display: block;
  width: calc(100% - 10px);
  margin-right: 10px;
  height: 30px;
}
#animationBottom p {
  float: left;
  width: calc(100% - 300px);
  margin: 0px;
  height: 30px;
  line-height: 30px;
  font-size: 9pt;
  font-style: italic;
  text-align: right;
}
#animationBottom button {
  width: 120px;
  height: 30px;
  display: inline-block;
  margin-left: 10px;
}

#overlay {
  background-color: rgba(0, 0, 0, 0);
  bottom: 0;
  left: 0;
  position: fixed;
  right: 0;
  top: 0;
  z-index: 999;
}
.ui-widget {
    font-family: "Inter", sans-serif !important;
}


#loadingOverlay {
  position: fixed;
  display: flex;
  z-index: 999;

  bottom: 0;
  left: 0;
  right: 0;
  top: 0;

  background-color: rgba(255, 255, 255, 0.66);
}
#loadingInner {
  width: 100%;
  height: 500px;
  margin: auto;
  vertical-align: top;
  display: inline-block;
  text-align: center;
}
#loadingInner p {
    font-size: 10pt;
}



::-webkit-scrollbar-track {
   -webkit-box-shadow: inset 0 0 6px rgba(0,0,0,0.1);
   box-shadow: inset 0 0 6px rgba(0,0,0,0.1);
   background-color: rgb(200, 200, 200, 0.5);
   border-radius: 10px;
 }
 
::-webkit-scrollbar {
   width: 10px;
   background-color: #F5F5F5;
 }
 
::-webkit-scrollbar-thumb {
   border-radius: 10px;
   background-color: #4b753e;
 }